;; ======================================================================== ;;
;;  Global music definitions                                                ;;
;; ======================================================================== ;;
MUSIC       PROC

;; ------------------------------------------------------------------------ ;;
;;  Pitch effects                                                           ;;
;; ------------------------------------------------------------------------ ;;
@@pitch01   DECLE   0, 0, 0, 0
@@pitch02   DECLE   0, 0, 12, 12

;; ------------------------------------------------------------------------ ;;
;;  Envelopes                                                               ;;
;; ------------------------------------------------------------------------ ;;

@@env01     DECLE   2
            DECLE   $FFEE, $DDCC, $BA98, $7654
            DECLE   $3210, $0000, $0000, $0000
            DECLE   $0000, $0000, $0000, $0000
            DECLE   $0000, $0000, $0000, $0000

@@env02     DECLE   2
            DECLE   $FEDC, $BA98, $7654, $3210
            DECLE   $0000, $0000, $0000, $0000
            DECLE   $0000, $0000, $0000, $0000
            DECLE   $0000, $0000, $0000, $0000
            
@@env03     DECLE   1
            DECLE   $EEDD, $CCBB, $A987, $6543
            DECLE   $2100, $0000, $0000, $0000
            DECLE   $0000, $0000, $0000, $0000
            DECLE   $0000, $0000, $0000, $0000

@@env04     DECLE   1
            DECLE   $FFFF, $EEEE, $DDDD, $CCCC
            DECLE   $BBBB, $AAAA, $9999, $8888
            DECLE   $7777, $6666, $5555, $4444
            DECLE   $3333, $2222, $1111, $0000
            
            
;; ------------------------------------------------------------------------ ;;
;;  Drums                                                                   ;;
;; ------------------------------------------------------------------------ ;;

@@drum1:    ; Kick     
            DRUM($900, 0, 1, 0, $F)
            DRUM($900, 0, 1, 0, $D)
            DRUM($900, 0, 1, 0, $9)
            DRUM($900, 0, 1, 0, $5)
            DRUM(0, 0, 0, 0, 0)
            DRUM(0, 0, 0, 0, 0)
            DRUM(0, 0, 0, 0, 0)
            DRUM(0, 0, 0, 0, 0)

@@drum2:    ; Snare
            DRUM($350, $10, 1, 0, $D)
            DRUM($350, $06, 1, 1, $C)
            DRUM($350, $06, 1, 1, $B)
            DRUM($350, $1F, 1, 1, $9)
            DRUM($350, $1F, 1, 1, $7)
            DRUM($350, $1F, 0, 1, $5)
            DRUM($350, $1F, 0, 1, $3)
            DRUM($350, $1F, 0, 1, $1)

@@hithat:   ; Hi-hat    
            DRUM($120, $04, 1, 1, $A)
            DRUM($120, $04, 0, 1, $5)
            DRUM(0, 0, 0, 0, 0)
            DRUM(0, 0, 0, 0, 0)
            DRUM(0, 0, 0, 0, 0)
            DRUM(0, 0, 0, 0, 0)
            DRUM(0, 0, 0, 0, 0)
            DRUM(0, 0, 0, 0, 0)

@@drum3:    ; Kick/snare hybrid?
            DRUM($900, $00, 1, 0, $F)
            DRUM($350, $06, 1, 1, $C)
            DRUM($900, $00, 1, 0, $9)
            DRUM($350, $1F, 1, 1, $9)
            DRUM($000, $00, 0, 0, $0)
            DRUM($350, $1F, 0, 1, $5)
            DRUM($000, $00, 0, 0, $0)
            DRUM($350, $1F, 0, 1, $1)
            
            ENDP

;; ======================================================================== ;;
;;  Song #00                                                                ;;
;; ======================================================================== ;;
SONG00      PROC

;; ------------------------------------------------------------------------ ;;
;;  Speed / Pointers                                                        ;;
;; ------------------------------------------------------------------------ ;;
            DECLE   6, @@patterns, @@instr

;; ------------------------------------------------------------------------ ;;
;;  Order of patterns                                                       ;;
;; ------------------------------------------------------------------------ ;;
            DECLE   0, 1, 2, 3, 4, 5, 6, (-7 AND $FFFF)

;; ------------------------------------------------------------------------ ;;
;;  Details of patterns                                                     ;;
;; ------------------------------------------------------------------------ ;;
@@patterns  
            DECLE   32, @@drums01, @@bass01, @@mel01        ; 1
            DECLE   32, @@drums01, @@bass02, @@mel02        ; 2
            DECLE   32, @@drums01, @@bass03, @@mel03        ; 3
            DECLE   32, @@drums01, @@bass04, @@mel04        ; 4
            DECLE   32, @@drums01, @@bass05, @@mel05        ; 5
            DECLE   32, @@drums01, @@bass06, @@mel06        ; 6
            DECLE   128, @@drums02, @@mel07, @@harm_bass07   ; 7

;; ------------------------------------------------------------------------ ;;
;;  Standard instruments (pitch effect, vibrato, envelope)                  ;;
;; ------------------------------------------------------------------------ ;;
@@instr     
            DECLE   MUSIC.pitch01, 0, MUSIC.env01
            DECLE   MUSIC.pitch01, 1, MUSIC.env01
            DECLE   MUSIC.pitch01, 1, MUSIC.env03
            DECLE   MUSIC.pitch01, 1, MUSIC.env04

;; ------------------------------------------------------------------------ ;;
;;  Drums                                                                   ;;
;; ------------------------------------------------------------------------ ;;
            DECLE   MUSIC.drum1
            DECLE   MUSIC.drum2
            DECLE   MUSIC.hithat
            DECLE   MUSIC.drum3

;; ------------------------------------------------------------------------ ;;
;;  Patterns                                                                ;;
;; ------------------------------------------------------------------------ ;;

@@silence: ; Nothin'
            NOTES("C-1 10F", "C-1 10F", "", "")            

;-----------------------------------------------------------------------------            

@@drums01
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 3A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")

            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 3A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            

@@bass01  
            NOTES("G#2 1C1", "G#2 1C7", "D#2 1C1", "G#2 1C1")
            NOTES("D#2 1C1", "D#2 1C1", "D#2 1C7", "C-2 1C3")
            NOTES("A#1 1C1", "", "", "") 

@@mel01  
            NOTES("C-4 3E1", "D#4 3E3", "D#4 3E3", "D#4 3E3")
            NOTES("F-4 3E3", "D#4 3E0", "F-4 3D0", "D#4 3EB") 
              
;-----------------------------------------------------------------------------

@@bass02:
            NOTES("G#2 1C1", "G#2 1C7", "D#2 1C1", "G#2 1C1")
            NOTES("D#2 1C1", "C#2 1C1", "C#2 1C7", "G#1 1C1")
            NOTES("C#2 1C1", "G#1 1C1", "", "") 

@@mel02: 
            NOTES("C-4 3E1", "D#4 3E3", "D#4 3E0", "F-4 3D0")
            NOTES("D#4 3E1", "C#4 3E3", "C#4 3EF", "C-1 201")
            
            
;-----------------------------------------------------------------------------

@@bass03:
            NOTES("C#2 1C1", "C#2 1C7", "G#1 1C1", "C#2 1C1")
            NOTES("G#1 1C1", "G#2 1C1", "G#2 1C7", "D#2 1C1")
            NOTES("G#2 1C1", "D#2 1C1", "", "")

@@mel03: 
            NOTES("C#4 3E3", "C#4 3E1", "D#4 3E3", "C#4 3E3") 
            NOTES("C#4 3E0", "C-4 3E0", "C-4 3ED", "A#3 3E0") 
            NOTES("G#3 3E0", "", "", "")                      
            
;-----------------------------------------------------------------------------

@@bass04: 
            NOTES("D#2 1C1", "D#2 1C7", "A#1 1C1", "D#2 1C1")
            NOTES("A#1 1C1", "D#2 1C1", "D#2 1C7", "G-2 1C1")
            NOTES("D#2 1C1", "A#1 1C1", "", "")
            
@@mel04: 
            NOTES("C-4 3E0", "G#3 3E0", "A#3 3EF", "NUL 3E7")
            NOTES("G#3 3E1", "A#3 3E1", "C-4 3E1", "")
            
;-----------------------------------------------------------------------------

@@bass05:
            NOTES("G#2 1C1", "G#2 1C7", "D#2 1C1", "G#2 1C1")
            NOTES("D#2 1C1", "C-2 1C1", "C-2 1C7", "A#1 1C1")
            NOTES("C-2 1C1", "F-1 1C1", "", "") 
                

@@mel05:
            NOTES("D#3 3E9", "C#4 3E1", "C-4 3E1", "A#3 3E3")
            NOTES("G#3 3E3", "C-4 3E3", "G#3 3E1", "A#3 3E1")
            NOTES("C-4 3E1", "", "", "")
           
        
;-----------------------------------------------------------------------------        
            
@@bass06:
            NOTES("F-2 1C1", "F-2 1C7", "C-2 1C1", "F-2 1C1")
            NOTES("C-2 1C1", "G#2 1C1", "G#2 1C7", "D#2 1C1")
            NOTES("G#2 1C1", "D#2 1C1", "", "")
                

@@mel06:            
            NOTES("F-3 3E9", "C#4 3E1", "C-4 3E1", "A#3 3E3")
            NOTES("G#3 3E3", "C-4 3E7", "C-1 101", "")
            
;-----------------------------------------------------------------------------

@@drums02:
            
            NOTES("C-1 100", "", "", "")
            NOTES("F-4 475", "D#4 471", "C#4 475", "G#3 470")
            NOTES("DRM 4F0", "C-1 102", "DRM 4F0", "")          
            NOTES("C-1 10A", "", "", "")                        
            
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")
            NOTES("DRM 1A0", "C-1 300", "DRM 1A0", "C-1 300")      
            NOTES("DRM 2A0", "C-1 300", "DRM 3A0", "C-1 300")


@@mel07:
            NOTES("F-4 3E5", "D#4 3E1", "C#4 3E5", "G#3 3E1")   
            NOTES("G-3 3E7", "F-4 2D1", "F-4 2D1", "F-4 2D1")   
            NOTES("F-4 2D3", "D#4 3E7", "NUL 3B9", "D#4 2C1")   
            NOTES("D#4 3E3", "C#4 3E1", "C-4 3E1", "D#4 3E3")   
            
            NOTES("C#4 3E7", "NUL 3B9", "A#3 2D1", "A#3 2D3")   
            NOTES("C-4 3E3", "G#3 3E3", "G#3 3E3", "D#4 3E9")   
            NOTES("C-1 10F", "", "", "")                        
            
@@harm_bass07:
            NOTES("G#4 4B5", "F#4 4B1", "F-4 4B5", "D#4 4B1")   
            NOTES("A#3 4B5", "C-1 109", "", "")                 
            
            NOTES("D#2 1C9", "D#2 1C1", "G#2 1C1", "C-2 1C1")   
            NOTES("D#2 1C1", "D#2 1C7", "A#1 1C1", "D#2 1C1")   
            NOTES("A#1 1C1", "C#2 1C1", "C#2 1C7", "A#1 1C1")   
            NOTES("C#2 1C1", "A#1 1C1", "D#2 1C1", "D#2 1C7")   
            NOTES("A#1 1C1", "D#2 1C1", "A#1 1C1", "G#1 1C1")   
            NOTES("G#1 1C1", "G#1 1C1", "G#1 1C1", "C-2 1C1")   
            NOTES("C-2 1C1", "C-2 1C1", "C-2 1C1", "C#2 1C1")   
            NOTES("C#2 1C1", "C#2 1C1", "C#2 1C1", "D#2 1C1")   
            NOTES("D#2 1C1", "D#2 1C1", "D#2 1C1", "")          
                
            ENDP
