;------------------------------------------------------------------------------
;            
INIT_TINY   PROC

            DIS

            ; Reset the visible flag for the MOB
            MVI     0, R0
            ANDI    #11110111111111b, R0
            MVO     R0, 0
            
            ; Initialize the state
            MVII    #ISR_STATES -1, R0
            MVO     R0, STATE

            ; Setup the border and color-stack colors
            CLRR    R0
            MVO     R0, BORD_COLOR
            MVO     R0, CS0_COLOR
            MVO     R0, CS2_COLOR
            MVO     R0, CS1_COLOR
            MVO     R0, CS3_COLOR
            
            ; Put cards into the BACKTAB
            CALL    LOAD_BTAB
            DECLE   CARDS_TINY

            ; Initialize the pointer into the frame sequence table
            MVII    #FRAME_SEQ_TINY.start, R0
            MVO     R0, NEXT_FRAME

            EIS

            PULR    PC
            ENDP            

;------------------------------------------------------------------------------
;
;
MODE_TINY   PROC
            
            ; Update the state and save it back out
            MVI     STATE, R0
            INCR    R0
            CMPI    #ISR_STATES, R0
            BNEQ    @@save_state
            CLRR    R0
@@save_state
            MVO     R0, STATE

            ;---
            ; Jump to where we should be based on the current state
            TSTR    R0
            BEQ     @@move_p1
            
            ;-----------------------------------------------------------------
            ; Stuff we do when we're not writing pixel data
            ;
            MVI     NEXT_FRAME, R0              ; Check the next frame in the 
            CMPI    #FRAME_SEQ_TINY.end, R0     ; sequence and see if we're done
            BNEQ    @@exit_early                ; Not time to reset the seq

            ; Restart the animation from the first frame
            MVII    #FRAME_SEQ_TINY.start, R0  
            MVO     R0, NEXT_FRAME
            
@@exit_early:
            PULR    PC
                        
            ;-----------------------------------------------------------------
            
            
@@move_p1   
            ; First set of 6 cards pulled from the current frame seq pointer
            MVI     NEXT_FRAME, R5
            MVI@    R5, R4
            MVO     R5, NEXT_FRAME     
            MVII    #MEMMAP.gram, R1
            MVII    #6, R0
            CALL    COPY_CARDS
            
            ; Second set of 6 cards is offset by 17 frames into the animation
            MVI     NEXT_FRAME, R5
            MVII    #MEMMAP.gram + (6*8), R1
            MVII    #6, R0
            ADDI    #17, R5
            CMPI    #FRAME_SEQ_TINY.end, R5
            BLT     @@copy2
            SUBI    #FRAME_SEQ_TINY.end - FRAME_SEQ_TINY, R5
@@copy2
            MVI@    R5, R4
            CALL    COPY_CARDS                
                        
            ; Third set of 6 cards is offset by 34 frames into the animation
            MVI     NEXT_FRAME, R5
            MVII    #MEMMAP.gram + (12*8), R1
            MVII    #6, R0
            ADDI    #34, R5
            CMPI    #FRAME_SEQ_TINY.end, R5
            BLT     @@copy3
            SUBI    #FRAME_SEQ_TINY.end - FRAME_SEQ_TINY, R5
@@copy3
            MVI@    R5, R4
            CALL    COPY_CARDS                

@@exit
            PULR    PC
            ENDP