;------------------------------------------------------------------------------
; Allocate 8-bit variables in Scratch RAM
;------------------------------------------------------------------------------

            ; Address of the interrupt service routine
                    ORG         $0100, $0100, "-RWBN"
ISRVEC1             RMB         1
ISRVEC2             RMB         1

            ; Pick a spot for program vars
                    ORG         $01C0, $01C0, "-RWBN"

            ; 8-bit Tracker vars
G_FAD               RMB         1
REF_M               RMB         1
NOTE_A              RMB         1
NOTE_B              RMB         1
NOTE_C              RMB         1
REF_A               RMB         1
REF_B               RMB         1
REF_C               RMB         1
VOL_A               RMB         1
VOL_B               RMB         1
VOL_C               RMB         1
INSTR_A             RMB         1
INSTR_B             RMB         1
INSTR_C             RMB         1
COUNT_A             RMB         1
COUNT_B             RMB         1
COUNT_C             RMB         1
COUNT_M             RMB         1
COUNT_P             RMB         1
PAT                 RMB         1

            ; 8-bit program vars
STATE               RMB         1
MOB_UPD_COUNTER     RMB         1   ; Decrements every tick, updates at 0

H_DELAY             RMB         1
H_SCR_COUNTER       RMB         1

BORD_COLOR          RMB         1
CS0_COLOR           RMB         1
CS1_COLOR           RMB         1
CS2_COLOR           RMB         1
CS3_COLOR           RMB         1


;------------------------------------------------------------------------------
; Allocate 16-bit variables in System RAM
;------------------------------------------------------------------------------
SYSTEM              ORG         $2F0, $2F0, "-RWBN"

            ; 16-bit Tracker vars
SONG                RMB         1
INS_PTR             RMB         1
POS_A               RMB         1
POS_B               RMB         1
POS_C               RMB         1

            ; 16-bit program vars
F_PTR               RMB         1   ; Ptr to where we left off within the frame data
NEXT_FRAME          RMB         1   ; Ptr to the next entry in the frame sequence table
NEXT_MOB            RMB         1   ; Ptr to the next entry in the MOB frame seq table

THIS_MODE           RMB         1   ; Ptr to the current entry in the mode sequence table
MODE_COUNTER        RMB         1   ; Ticks to run the current mode

MOB_X_VEL           RMB         1   ; Current MOB X velocity
MOB_Y_VEL           RMB         1   ; Current MOB Y velocity

            ; MOB register shadow
MOB_SHAD    PROC
@@x0                RMB         1
@@x1                RMB         1
@@x2                RMB         1
@@x3                RMB         1
@@x4                RMB         1
@@x5                RMB         1
@@x6                RMB         1
@@x7                RMB         1

@@y0                RMB         1
@@y1                RMB         1
@@y2                RMB         1
@@y3                RMB         1
@@y4                RMB         1
@@y5                RMB         1
@@y6                RMB         1
@@y7                RMB         1

@@a0                RMB         1
@@a1                RMB         1
@@a2                RMB         1
@@a3                RMB         1
@@a4                RMB         1
@@a5                RMB         1
@@a6                RMB         1
@@a7                RMB         1

@@end
            ENDP

; Need room for the stack above our vars
STACK               RMB         32
